variables:
  VERNUM:
    description: "Choose one to incremement the version and publish a release - note that alpha and beta will increment minor if you're already on a patch."
    options:
      - none
      - alpha
      - beta
      - patch
      - minor
      - major
    value: none


# Increment the semantic version and create a .version file job artifact.
# Have to use GIT_DEPTH 0 to make sure we get all historical tags

1-create-versioned-release:
  stage: deploy
  rules:
    - if: $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH
      when: never
    - if: $VERNUM == 'none'
      when: never
    - if: $CI_COMMIT_BRANCH
  variables:
    GIT_DEPTH: 0
  image: python:3.11
  script:
    # - if [ $VERNUM = 'none' ]; then echo "No version"; exit 0; fi
    - pip install vernum==5.\*
    - vernum $VERNUM > .version
    - echo "Updated version to $(cat .version)"
  artifacts:
    paths:
      - .version


# Conditions for releasing live in before_script

.release:
  stage: deploy
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  # before_script:
  #   - if [ ! -f .version ]; then exit 0; fi
  #   - if [ -z "$(cat .version)" ]; then exit 1; fi
  #   - if [ "$(cat .version)" = 'none' ]; then exit 0; fi


# Capture the new version number in a GitLab release and Git tag on the repo

2-tag-release-in-gitlab:
  extends: .release
  needs:
    - 1-create-versioned-release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  script:
    - release-cli create --name "v$(cat .version)" --description "v$(cat .version)" --tag-name "v$(cat .version)"
    - echo "Created GitLab Release and Git tag for $(cat .version)"


# Extend .versioned with your final build, referencing the .version file contents for the version number if required

.versioned:
  extends: .release
  needs:
    - 1-create-versioned-release
    - 2-tag-release-in-gitlab
